unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, CheckLst,Tools,Tools_File;

type

  { TForm1 }

  RPapier = record
    Buffer:TBitMap;
  end;
  
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    CheckListBox1: TCheckListBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    ScrollBox1: TScrollBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure CheckListBox1Click(Sender: TObject);
    procedure CheckListBox1ItemClick(Sender: TObject; Index: integer);
    procedure FormCreate(Sender: TObject);
    procedure Paintbox1Paint(Sender: TObject);
    procedure Paintbox1Resize(Sender: TObject);
  private
    { private declarations }
  public
//    Buffer:TBitMap;
    Seiten:array of RPapier;
    procedure ClearBuffer(index:Integer);
    procedure Flip(index:Integer);
    procedure AddSeite;

    { public declarations }
  end; 

var
  Form1: TForm1; 
  r:TRect;

implementation

{ TForm1 }

procedure TForm1.AddSeite;
begin
  SetLength(Seiten,high(seiten)+2);

  seiten[high(seiten)].Buffer:=TBitMap.Create;
  seiten[high(seiten)].Buffer.Width:=2480;
  seiten[high(seiten)].Buffer.Height:=3508;
  r:=seiten[high(seiten)].Buffer.canvas.ClipRect;

  
  Paintbox1.Width:=seiten[high(seiten)].Buffer.Width+5;
  Paintbox1.Height:=seiten[high(seiten)].Buffer.Height+5;
  Paintbox1.Font.name:='-adobe-courier-medium-r-normal-*-*-*-*-*-m-*-iso10646-1';
  seiten[high(seiten)].Buffer.Canvas.Font:=TFont.Create;
  seiten[high(seiten)].Buffer.Canvas.Font.Name:='-adobe-courier-medium-r-normal-*-*-*-*-*-m-*-iso10646-1';

  ClearBuffer(high(seiten));
end;

procedure TForm1.Flip(index:Integer);
begin
  if index > -1 then begin
    with Seiten[index] do begin
      Paintbox1.Canvas.copyRect(r,buffer.Canvas,r);
    end;
  end
  else begin

    for index:=0 to High(seiten) do begin
      with Seiten[index] do begin
        Paintbox1.Canvas.copyRect(r,buffer.canvas,r);
      end;
    end;
  end;
end;

procedure TForm1.ClearBuffer(index:Integer);
begin
  if index > -1 then begin
    with Seiten[index] do begin
      buffer.canvas.Brush.color:=clWhite;
      buffer.Canvas.FillRect(0,0,buffer.Width,buffer.Height);
      buffer.Canvas.Rectangle(100,100,buffer.Width-100,buffer.Height-100);
    end;
    Flip(index);
  end
  else begin
    Paintbox1.Canvas.FillRect(0,0,Paintbox1.Width,Paintbox1.Height)
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  GetAllFiles(ComboBox1.Text,'',CheckListBox1.Items,True);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin

end;

procedure TForm1.BitBtn5Click(Sender: TObject); // zeichnen
var
  i,x,px,py,pw,ph:Integer;
  t:TStringList;
  TR:TRect;
  str:String;
begin
  AddSeite;
  px:=105; py:=105;
  t:=TStringList.Create;
  for i:=0 to CheckListBox1.Items.Count-1 do begin
    if CheckListBox1.Checked[i] = True then begin
      t.Clear;
      t.LoadFromFile(String(CheckListBox1.Items.Objects[i]));

      for x:=0 to t.count-1 do begin
        str:=t.strings[x];
        seiten[high(Seiten)].Buffer.Canvas.Font.Name:='-adobe-courier-medium-r-normal-*-*-500-*-*-*-*-iso10646-1';
        seiten[high(Seiten)].Buffer.Canvas.Font.Size:=24;

        pw:=seiten[high(Seiten)].Buffer.Canvas.TextWidth(str);
        ph:=seiten[high(Seiten)].Buffer.Canvas.TextHeight(str);
        seiten[high(Seiten)].Buffer.Canvas.Refresh;

        seiten[high(Seiten)].Buffer.Canvas.TextOut(px,py,str);
        
        py:=py+ph+5;
      end;
        py:=py+ph+ph;

    end;
  end;
//  flip(-1);
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
  seiten[0].Buffer.SaveToFile('/media/hda7/test.bmp')
end;

procedure TForm1.CheckListBox1Click(Sender: TObject);
begin
  if CheckListBox1.ItemIndex > -1 then
  Caption:=String(CheckListBox1.Items.Objects[CheckListBox1.ItemIndex]);
end;

procedure TForm1.CheckListBox1ItemClick(Sender: TObject; Index: integer);
begin

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ClearBuffer(-1);
  SetLength(Seiten,0);
  Paintbox1.Canvas.Clipping:=True;

  DoubleBuffered:=True;
  ScrollBox1.DoubleBuffered:=True;

  BitBtn1Click(Sender); // Alle Dateien einlesen
  BitBtn4Click(Sender); // Alle Dateien Öffnen
end;

procedure TForm1.Paintbox1Paint(Sender: TObject);
begin
  r:=Paintbox1.Canvas.ClipRect;
  Flip(-1)
end;

procedure TForm1.Paintbox1Resize(Sender: TObject);
begin

end;


initialization
  {$I Unit1.lrs}

end.

